package za.co.softco.rap.test;

import org.eclipse.equinox.app.IApplication;
import org.eclipse.equinox.app.IApplicationContext;
import org.eclipse.rwt.RWT;
import org.eclipse.rwt.lifecycle.IEntryPoint;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.application.WorkbenchAdvisor;

/**
 * This class controls all aspects of the application's execution
 * and is contributed through the plugin.xml.
 */
public class Application implements IApplication, IEntryPoint {
	public static final String ID = "za.co.softco.rap.test.default";

	protected Display build(final Display display, final Shell shell) {
		shell.setLayout(new FillLayout(SWT.HORIZONTAL));
		display.setData(RWT.ACTIVE_KEYS, new String[] { "SPACE", "X" });
		final Button button = new Button(shell, SWT.PUSH);
		button.setText("Hallo");
		button.setData(RWT.ACTIVE_KEYS, new String[] { "SPACE", "X" });
		button.addListener(SWT.KeyDown, new Listener() {
			@Override
			public void handleEvent(Event event) {
				System.out.println("Button key down");
				button.setText("Button key down");
			}
		});
		button.addSelectionListener(new SelectionListener() {
			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				System.out.println("Default selected");
				button.setText("Default selected");
			}
			
			@Override
			public void widgetSelected(SelectionEvent e) {
				System.out.println("Selected");
				button.setText("Selected");
			}
		});

		shell.addListener(SWT.KeyDown, new Listener() {
			private static final long serialVersionUID = 1L;
			@Override
			public void handleEvent(Event event) {
				System.out.println("Key down");
			}
		});
		shell.addListener(SWT.MouseDown, new Listener() {
			private static final long serialVersionUID = 1L;
			@Override
			public void handleEvent(Event event) {
				System.out.println("Shell mouse down");
			}
		});
		display.addFilter(SWT.KeyDown, new Listener() {
			private static final long serialVersionUID = 1L;
			@Override
			public void handleEvent(Event event) {
				System.out.println("Display key down");
			}
		});
		display.addFilter(SWT.MouseDown, new Listener() {
			private static final long serialVersionUID = 1L;
			@Override
			public void handleEvent(Event event) {
				System.out.println("Display mouse down");
			}
		});
		
		return display;
	}
	
	@Override
	public Object start(IApplicationContext context) throws Exception {
		Display display;
		try {
			display = PlatformUI.createDisplay();
		} catch (IllegalStateException e) {
			display = new Display();
		}
		build(display, new Shell(display, SWT.RESIZE));
		WorkbenchAdvisor advisor = new ApplicationWorkbenchAdvisor();
		return PlatformUI.createAndRunWorkbench(display, advisor);
	}

	@Override
	public int createUI() {
		Display display; // = new Display();
		display = PlatformUI.createDisplay();
		Shell shell = new Shell(display, SWT.RESIZE);
		build(display, shell);
		shell.open();
		System.out.println("Shell opened");
		return 0;
	}
	
	public void stop() {
		// Do nothing
	}
}
